
#include "utils.bas"
#include "file.bi"

const OPTION_UPCASE = ""
const OPTION_LOWCASE = "-l"
const OPTION_CAPITALIZED = "-c"
const OPTION_INDIVIDUAL = "-i"
const DEFAULT_OPTION = OPTION_UPCASE
const BAS = ".bas"
const BI = ".bi"

dim as string myoption = DEFAULT_OPTION

declare sub BeautifyFile(byval as string, byval as string, byval as string)
declare sub BeautifyDirectory(byval as string, byval as string, byval as string)

dim shared flog as integer
flog = FreeFile()
open ExePath & "\" & "beautify-log.txt" for output as #flog
print #flog, Time

if not FileExists(ExePath & "\" & "fbeauty.exe") then
  print #flog, "Cannot find fbeauty.exe."
  close #flog
  end
end if

if Command(1) = "" then
  print #flog, "Missing parameter (file or directory expected)."
  close #flog
  end
end if

if (Command(2) = "-l") _
or (Command(2) = "-c") _
or (Command(2) = "-i") then
  myoption = Command(2)
end if

if DirExists(Command(1)) then
  if FindExt(Command(1), BAS) _
  or FindExt(Command(1), BI) then
    BeautifyDirectory(ExePath & "\" & "fbeauty.exe", Command(1) & "\", myoption)
  else
    print #flog, "No FreeBASIC source file found in the directory."
  end if
elseif FileExists(Command(1)) then
  if (LCase(ExtractFileExt(Command(1))) = BAS) _
  or (LCase(ExtractFileExt(Command(1))) = BI) then 
    BeautifyFile(ExePath & "\" & "fbeauty.exe", Command(1), myoption)
  else
    print #flog, "The file doesn't seem to be a FreeBASIC source file."
  end if
else
  print #flog, "Invalid parameter (file or directory expected)."
end if

close #flog

sub Filter(byval aSource as string, byval aNewFile as string, byval aFilter as string, byval aOption as string)
  dim s as string
  dim as uinteger f1, f2
  f1 = FreeFile()
  open aNewFile for output as #f1
  f2 = FreeFile()
  open pipe aFilter & " " & aOption & " < " & aSource for input as #f2
  do until Eof(f2)
    line input #f2, s
    print #f1, s
  loop
  close #f2
  close #f1
  print #flog, "Beautified " & aNewFile & "."
end sub

sub BeautifyFile(byval aFilter as string, byval aPath as string, byval aOption as string)
  const TEMP = ".temp"
  dim s as string = ChangeFileExt(aPath, TEMP)
  if Name(aPath, s) = 0 then
    Filter(s, aPath, aFilter, aOption)
    Kill(s)
  else
    print #flog, "Error renaming " & aPath & " to " & s & ". Operation aborted."
  end if
end sub

sub BeautifyDirectory(byval aFilter as string, byval aPath as string, byval aOption as string)
  const PRESERVE_CONTENT = -1
  dim a() as string
  GetExt(aPath, BAS, a())
  GetExt(aPath, BI, a(), PRESERVE_CONTENT)
  for i as integer = LBound(a) to UBound(a)
    BeautifyFile(aFilter, aPath & a(i), aOption)
  next i
end sub
